<template>
  <v-btn
    rounded
    prepend-icon="mdi-phone-plus-outline"
    class="text-teal-600"
    variant="tonal"
  >
    Добавить

    <v-menu
      v-model="isShown"
      location="top start"
      transition="scale-transition"
      activator="parent"
      :close-on-content-click="false"
    >
      <Container
        class="my-4 p-4 drop-shadow-md shadow-none"
        reset-paddings
      >
        <div class="mb-4 font-light text-lg text-gray-500 uppercase">
          Добавление номера
        </div>

        <v-text-field
          v-model="newPhone"
          :rules="[validatePhone]"
          :maxlength="MAX_GUEST_PHONE_LENGTH"
          placeholder="Номер телефона"
          inputmode="tel"
          class="min-w-[16rem]"
          @keydown.space.prevent
        />

        <v-alert class="text-gray-400 text-sm mt-4">
          <template #prepend>
            <v-icon icon="mdi-alert" />
          </template>

          <template #text>
            <section>
              Введите номер телефона без <br>
              пробелов и специальных символов <br>
            </section>
            <section class="pt-4">
              Например: 71234567890
            </section>
          </template>
        </v-alert>

        <Feedback
          type="error"
          :message="feedback"
          classes="mt-4"
        />

        <section class="pt-4">
          <v-btn
            rounded
            variant="tonal"
            class="font-bold mr-4"
            @click="isShown = false"
          >
            Отмена
          </v-btn>

          <v-btn
            rounded
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            :class="{ 'opacity-50': !isDataFilled }"
            :readonly="!isDataFilled"
            :loading="isLoading"
            @click="onCreateClick"
          >
            Добавить
          </v-btn>
        </section>
      </Container>
    </v-menu>
  </v-btn>

  <v-bottom-sheet
    v-if="confirmationGuest"
    v-model="isConfirmationShown"
    persistent
    content-class="!shadow-none"
  >
    <div class="bg-white p-6 rounded-t-[12px] w-full md:w-4/5 lg:w-2/3 xl:w-3/5 mx-auto">
      <section class="flex items-center flex-wrap">
        <section class="flex items-center flex-auto">
          <section class="flex-initial flex justify-center items-center">
            <TextAvatar :value="confirmationGuest.name" />
          </section>

          <section class="flex-auto px-2">
            <div class="text-lg">
              {{ confirmationGuest.name }}
            </div>

            <section class="flex items-end text-sm text-gray-500">
              <v-icon icon="mdi-music-accidental-sharp" />
              <span>{{ String(confirmationGuest.id).padStart(4, '0') }}</span>
            </section>
          </section>
        </section>

        <section class="flex gap-4 md:block text-left md:text-right w-full md:w-auto mt-4 md:mt-0">
          <v-chip class="shrink-0">
            <template #prepend>
              <v-icon
                icon="mdi-phone"
                class="mr-2"
              />
            </template>

            <template #default>
              {{ getFormattedPhoneNumber(newPhone.trim()) }}
            </template>
          </v-chip>

          <div class="flex items-center text-red-800">
            Номер уже используется
          </div>
        </section>
      </section>

      <v-divider class="border-gray-800 my-4" />

      <section class="flex items-center justify-between">
        <v-btn
          rounded
          variant="tonal"
          size="large"
          class="font-bold mr-4"
          @click="onConfirmationCancel"
        >
          Отмена
        </v-btn>

        <v-btn
          rounded
          class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
          size="large"
          @click="onConfirmationProceed"
        >
          Заменить
        </v-btn>
      </section>
    </div>
  </v-bottom-sheet>
</template>

<script setup lang="ts">
import { computed, ref, watch } from 'vue';

import { HttpClient } from '@/http';
import { createStringValidator } from '@/validators';

import { MIN_GUEST_PHONE_LENGTH, MAX_GUEST_PHONE_LENGTH } from '@/declarations';
import { getFormattedPhoneNumber } from '@/utils';

import Container from '@/components/layout/Container.vue';
import TextAvatar from '@/components/content/TextAvatar.vue';
import Feedback from '@/components/content/Feedback.vue';

const emit = defineEmits(['create']);

const validatePhone = createStringValidator({
  required: true,
  length: { min: MIN_GUEST_PHONE_LENGTH, max: MAX_GUEST_PHONE_LENGTH },
});

const isLoading = ref(false);
const isShown = ref(false);

const isConfirmationShown = ref(false);
const confirmationGuest = ref<IGuest | null>(null);

const newPhone = ref('');
const feedback = ref('');

const isDataFilled = computed(() => {
  return validatePhone(newPhone.value) === true;
});

const onConfirmationCancel = () => {
  isLoading.value = false;
  isConfirmationShown.value = false;

  confirmationGuest.value = null;
};

const onConfirmationProceed = () => {
  emit('create', {
    phone: newPhone.value.trim(),
    force: true,
  });

  isLoading.value = false;
  isShown.value = false;
  isConfirmationShown.value = false;
};

const onCreateClick = async () => {
  isLoading.value = true;

  const { data: { values, error } } = (
    await HttpClient.post<PhoneAvailabilityCheckResult[]>(
      '/v1/guests/phones/check-availability',
      { phones: [newPhone.value.trim()] },
    )
  );

  isLoading.value = false;

  if (!values || error) {
    feedback.value = error?.message ?? 'Не удалось выполнить запрос';
    return;
  }

  const [validationStatus] = values;

  if (!validationStatus.available) {
    isConfirmationShown.value = true;
    confirmationGuest.value = validationStatus.guest;

    return;
  }

  emit('create', {
    phone: newPhone.value.trim(),
    force: false,
  });

  isShown.value = false;
};

watch(isShown, () => newPhone.value = '');
</script>